## Python. Uczenie maszynowe (wydanie III) - repozytorium kodu

[![Python 3.7](https://img.shields.io/badge/Python-3.7-blue.svg)](#)
[![Licencja](https://img.shields.io/badge/Code%20License-MIT-blue.svg)](LICENCJA.txt)

Repozytoria kodu z wydania I i II (w wersji angielskiej) dostępne są pod następującymi adresami:

- https://github.com/rasbt/python-machine-learning-book and
- https://github.com/rasbt/python-machine-learning-book-2nd-edition

**Python. Uczenie maszynowe. Wydanie III**  

Data publikacji: 12.12.2019r.

Oprawa miękka: 770 stron  
Wydawnictwo: Packt Publishing  
Język: angielski

ISBN-10: 1789955750   
ISBN-13: 978-1789955750  
Kindle ASIN: B07VBLX2W7 

[<img src="./.other/cover_1.jpg" width="248">](https://www.amazon.com/Python-Machine-Learning-scikit-learn-TensorFlow/dp/1789955750/)


## Odnośniki

- [Serwis Amazon](https://www.amazon.com/Python-Machine-Learning-scikit-learn-TensorFlow/dp/1789955750/)
- [Wydawnictwo Packt](https://www.packtpub.com/data/python-machine-learning-third-edition)



## Spis treści i notatników

**Przydatne informacje dotyczące instalacji i konfiguracji znajdziesz w [pliku CZYTAJ.md umieszczonym w rozdziale 1.](r01/CZYTAJ.md).**

**Zwróć uwagę, że przykładowy kod stanowi uzupełnienie książki, które stworzyłem dla Twojej wygody; notatniki te mogą być nieprzydatne bez zapoznania się ze wzorami i tekstem opisowym.**   


1. Umożliwianie komputerom uczenia się z danych [[otwórz katalog](r01)] 
2. Trenowanie prostych algorytmów uczenia maszynowego w celach klasyfikacji [[otwórz katalog](r02)] 
3. Stosowanie klasyfikatorów uczenia maszynowego za pomocą biblioteki scikit-learn [[otwórz katalog](r03)] 
4. Tworzenie dobrych zestawów danych uczących — wstępne przetwarzanie danych [[otwórz katalog](r04)] 
5. Kompresja danych poprzez redukcję wymiarowości [[otwórz katalog](r05)] 
6. Najlepsze metody oceny modelu i strojenie parametryczne [[otwórz katalog](r06)]
7. Łączenie różnych modeli w celu uczenia zespołowego [[otwórz katalog](r07)] 
8. Wykorzystywanie uczenia maszynowego w analizie sentymentów [[otwórz katalog](r08)] 
9. Wdrażanie modelu uczenia maszynowego do aplikacji sieciowej [[otwórz katalog](r09)]  
10. Przewidywanie ciągłych zmiennych docelowych za pomocą analizy regresywnej [[otwórz katalog](r10)] 
11. Praca z nieoznakowanymi danymi — analiza skupień [[otwórz katalog](r11)] 
12. Implementowanie wielowarstwowej sieci neuronowej od podstaw [[otwórz katalog](r12)] 
13. Równoległe przetwarzanie sieci neuronowych za pomocą biblioteki TensorFlow [[otwórz katalog](r13)] 
14. Czas na szczegóły — mechanizm działania biblioteki TensorFlow [[otwórz katalog](r14)] 
15. Klasyfikowanie obrazów za pomocą głębokich splotowych sieci neuronowych [[otwórz katalog](r15)]  
16. Modelowanie danych sekwencyjnych za pomocą rekurencyjnych sieci neuronowych [[otwórz katalog](r16)] 
17. Generatywne sieci przeciwstawne w zadaniach syntetyzowania nowych danych [[otwórz katalog](r17)]  
18. Uczenie przez wzmacnianie jako mechanizm podejmowania decyzji w skomplikowanych środowiskach [[otwórz katalog](r18)] 


--- 

<br>
<br>

Sebastian Raschka i Vahid Mirjalili. *Python Machine Learning, 3rd Ed*. Packt Publishing, 2019.

    @book{RaschkaMirjalili2019,  
    address = {Birmingham, UK},  
    author = {Raschka, Sebastian and Mirjalili, Vahid},  
    edition = {3},  
    isbn = {978-1789955750},   
    publisher = {Packt Publishing},  
    title = {{Python Machine Learning, 3rd Ed.}},  
    year = {2019}  
    }
